// ClientMenu.h: interface for the CClientMenu class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include "AbstractMenu.h"
#include "CourseLoader.h"
#include "NetworkManager.h"
#include "d3dfile.h"
#include "d3dfont.h"
#include "dxutil.h"

class CClientMenu : public CAbstractMenu
{
public:
	CClientMenu(CNetworkManager* pnetman);
	virtual ~CClientMenu();

    // CAbstractMenu functions
    virtual int  OnKeyDown(WPARAM wParam);
    virtual int  OnChar(WPARAM wParam);
    virtual int  FrameMove();

	// Device Initialization and Rendering Functions
    virtual void RenderMenu(int iWidth, int iHeight);
    virtual HRESULT InitDeviceObjects( LPDIRECT3DDEVICE8 pd3dDevice );
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();

private:
    HRESULT RenderText(int iWidth, int iHeight);

    TCHAR               m_pszHostAddr[256]; //address of the host  
    CD3DFont*           m_pStatusFont;      //font for displaying status messages
    CD3DFont*           m_pMenuFont;        //font for drawing menu options
    CNetworkManager*    m_pNetManager;      //pointer to the network manager
    UINT                m_iDelay;           //used for putting up timed messages

    //states that the client menu can be in
    enum ClientMenuState
    {
        INPUT_HOSTADDR   = 0,
        CONNECTING       = 1,
        WAIT_FOR_CONNECT = 2,
        CANCEL_CONNECT   = 3,
        CONNECTED        = 4,
        CONNECT_FAILED   = 5,
        CONNECT_LOST     = 6
    };
    UINT                m_iMenuState;    //the current state of the menu
    BOOL                m_bHasRendered;
};
