// CreditsMenu.h: interface for the CCreditsMenu class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include "AbstractMenu.h"
#include "dxutil.h"
#include "d3dfont.h"

class CCreditsMenu : public CAbstractMenu  
{
public:
	CCreditsMenu();
	virtual ~CCreditsMenu();

    // CAbstractMenu functions
    virtual int  OnKeyDown(WPARAM wParam);
    virtual int  FrameMove();

	// Device Initialization and Rendering Functions
    virtual void RenderMenu(int iWidth, int iHeight);
    virtual HRESULT InitDeviceObjects( LPDIRECT3DDEVICE8 pd3dDevice );
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();

private:
    HRESULT RenderText(int iWidth, int iHeight);

	static char* m_ppszCredits[];

	BOOL		 m_bCreditsDone;
    int          m_iDelayCnt;         //used as a delay for this menu
    CD3DFont*    m_pFont;             // Font for drawing text
};