// GameMath.h: interface for the CGameMath class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include <D3DX8.h>

class CGameMath  
{
public:
    CGameMath();
    ~CGameMath();

    //returns whether there is an intersects in the XY plane and the
    //returns the distance in the Z direction at the intersection
    static BOOL GetLineIntersect(const D3DXVECTOR3& vFrom1, const D3DXVECTOR3& vTo1,
                                 const D3DXVECTOR3& vFrom2, const D3DXVECTOR3& vTo2,
                                 D3DXVECTOR3* pIntersect = NULL, FLOAT* fZdelta = NULL);

    //returns whether there is a perpendicular to the line segment that goes
    //through the given point, and returns the point on the line segment
    //the percent between the from and the two points of the intersection
    static BOOL GetPointPerp(const D3DXVECTOR3& vFrom, const D3DXVECTOR3& vTo,
                             const D3DXVECTOR3& vPoint, D3DXVECTOR3* pIntersectPt = NULL,
                             FLOAT* pfPercent = NULL);

    //calculates the camera view angle based on the direction vector
    static FLOAT CalculateCameraAngle(const D3DXVECTOR3& vDir);
};