// GoalFactory.cpp: implementation of the CGoalFactory class.
//
//////////////////////////////////////////////////////////////////////

#include "GoalFactory.h"

#include "ItemsGoneGoal.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGoalFactory::CGoalFactory()
{
    m_GoalVect.push_back(new CItemsGoneGoal());
}

CGoalFactory::~CGoalFactory()
{
    vector<CAbstractGoal*>::iterator it;
    for(it = m_GoalVect.begin(); it != m_GoalVect.end(); ++it)
        delete *it;
}

//returns a pointer to a new snake item from an identifier and a file
CAbstractGoal* CGoalFactory::CreateFromFile(const char* pszIdentifier, ifstream& infile)
{
    CAbstractGoal* pFoundItem;
    vector<CAbstractGoal*>::iterator it;
    for(it = m_GoalVect.begin(); it != m_GoalVect.end(); ++it)
    {
        if(pFoundItem = (*it)->Clone(pszIdentifier, infile))
        {
            return pFoundItem;
        }
    }
    return NULL;
}