// ItemsGoneGoal.cpp: implementation of the CItemsGoneGoal class.
//
//////////////////////////////////////////////////////////////////////

#include "ItemsGoneGoal.h"
#include "dxutil.h"
#include <crtdbg.h>     //for _ASSERT

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CItemsGoneGoal::CItemsGoneGoal() : m_pItemID(NULL), m_iItemIDSize(0)
{

}

CItemsGoneGoal::~CItemsGoneGoal()
{
    SAFE_DELETE_ARRAY( m_pItemID );
}

CAbstractGoal* CItemsGoneGoal::Clone(const char* pszIdentifier, ifstream& infile)
{
    _ASSERT(pszIdentifier);

    if(strcmp(pszIdentifier, "ITEMSGONE") == 0)
    {
        CItemsGoneGoal* pNewItem = new CItemsGoneGoal();
        pNewItem->ReadItemIDs(infile);
        return pNewItem;
    }
    return NULL;
}

BOOL CItemsGoneGoal::GoalCompleted(CItemManager* pItemMan, CSnakeManager* pSnakeMan)
{
    _ASSERT(pItemMan);
    for(UINT i = 0; i < m_iItemIDSize; ++i)
    {
        CItem* pItem = pItemMan->GetItem(m_pItemID[i]);
        _ASSERT(pItem);
        if(pItem->IsValid())
            return FALSE;
    }
    return TRUE;
}

//reads the IDs of the items to check for from the file
void CItemsGoneGoal::ReadItemIDs(ifstream& infile)
{
    SAFE_DELETE_ARRAY( m_pItemID );

    infile >> m_iItemIDSize;
    m_pItemID = new UINT[m_iItemIDSize];
    for(UINT i = 0; i < m_iItemIDSize; ++i)
    {
        infile >> m_pItemID[i];
    }
}