// LevelCompleteMenu.h: interface for the CLevelCompleteMenu class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include "AbstractMenu.h"
#include "d3dfile.h"
#include "d3dfont.h"
#include "dxutil.h"

class CLevelCompleteMenu : public CAbstractMenu
{
public:
	CLevelCompleteMenu(int iScore);
	virtual ~CLevelCompleteMenu();

    // CAbstractMenu functions
    virtual int  OnKeyDown(WPARAM wParam);
    virtual int  OnChar(WPARAM wParam);
    virtual int  FrameMove();

	// Device Initialization and Rendering Functions
    virtual void RenderMenu(int iWidth, int iHeight);
    virtual HRESULT InitDeviceObjects( LPDIRECT3DDEVICE8 pd3dDevice );
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();

private:
    HRESULT RenderText();

    static MenuItem m_pLevelCompleteMenuItems[];

    LPDIRECT3DVERTEXBUFFER8 m_pVB;           // vertex buffer shading the screen
    CD3DFont*               m_pScoreFont;
    CD3DFont*               m_pMenuFont;     // Font for drawing text
    SIZE                    m_ScreenSize;
    int                     m_iAlpha;
    int                     m_iCurSel;
    int                     m_iScore;

    LPDIRECT3DSURFACE8      m_pSavedSurface; //copy of the original back buffer
};