// LogoMenu.h: interface for the CLogoMenu class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include "AbstractMenu.h"
#include "d3dfile.h"
#include "d3dfont.h"
#include "dxutil.h"

class CLogoMenu : public CAbstractMenu
{
public:
	CLogoMenu();
	virtual ~CLogoMenu();

    // CAbstractMenu functions
    virtual int  OnKeyDown(WPARAM wParam);
    virtual int  FrameMove();

	// Device Initialization and Rendering Functions
    virtual void RenderMenu(int iWidth, int iHeight);
    virtual HRESULT InitDeviceObjects( LPDIRECT3DDEVICE8 pd3dDevice );
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
protected:
    UINT                    m_iDelayCnt;         //used as a delay for this menu
    LPDIRECT3DTEXTURE8      m_pLogoTex;
    int                     m_iAlpha;
    LPDIRECT3DVERTEXBUFFER8 m_pVBLogo;           // vertex buffer for logo texture
    LPDIRECT3DVERTEXBUFFER8 m_pVBSky;            // vertex buffer for logo texture

    BOOL                    m_bFadeOut;
};