// NetworkWinMenu.h: interface for the CNetworkWinMenu class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include "AbstractMenu.h"
#include "d3dfile.h"
#include "d3dfont.h"
#include "dxutil.h"
#include "NetworkManager.h"

class CNetworkWinMenu : public CAbstractMenu
{
public:
	CNetworkWinMenu(TCHAR* pszName, CNetworkManager* pNetManager);
	virtual ~CNetworkWinMenu();

    // CAbstractMenu functions
    virtual int  OnKeyDown(WPARAM wParam);
    virtual int  FrameMove();

	// Device Initialization and Rendering Functions
    virtual void RenderMenu(int iWidth, int iHeight);
    virtual HRESULT InitDeviceObjects( LPDIRECT3DDEVICE8 pd3dDevice );
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();

private:
    HRESULT RenderText();

    static MenuItem m_pNetworkWinMenuItems[];

    LPDIRECT3DVERTEXBUFFER8 m_pVB;           // vertex buffer shading the screen
    CD3DFont*               m_pNameFont;
    CD3DFont*               m_pMenuFont;     // Font for drawing text
    SIZE                    m_ScreenSize;
    int                     m_iAlpha;
    int                     m_iCurSel;
    TCHAR                   m_pszName[256];
    CNetworkManager*        m_pNetManager;

    LPDIRECT3DSURFACE8      m_pSavedSurface; //copy of the original back buffer
};