// OneSnakeGoal.cpp: implementation of the COneSnakeGoal class.
//
//////////////////////////////////////////////////////////////////////

#include "OneSnakeGoal.h"
#include "SnakeManager.h"
#include "dxutil.h"
#include <crtdbg.h>     //for _ASSERT

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

COneSnakeGoal::COneSnakeGoal()
{

}

COneSnakeGoal::~COneSnakeGoal()
{
}

CAbstractGoal* COneSnakeGoal::Clone(const char* pszIdentifier, ifstream& infile)
{
    _ASSERT(pszIdentifier);

    if(strcmp(pszIdentifier, "ONESNAKE") == 0)
    {
        return new COneSnakeGoal();
    }
    return NULL;
}

BOOL COneSnakeGoal::GoalCompleted(CItemManager* pItemMan, CSnakeManager* pSnakeMan)
{
    _ASSERT(pSnakeMan);
    return (pSnakeMan->GetNumLivingSnakes() <= 1);
}