// OptionsMenu.h: interface for the COptionsMenu class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include "AbstractMenu.h"
#include "d3dfile.h"
#include "d3dfont.h"
#include "dxutil.h"

class COptionsMenu : public CAbstractMenu
{
public:
	COptionsMenu();
	virtual ~COptionsMenu();

    // CAbstractMenu functions
    virtual int  OnKeyDown(WPARAM wParam);
    virtual int  FrameMove();

    // Device Initialization and Rendering Functions
    virtual void RenderMenu(int iWidth, int iHeight);
    virtual HRESULT InitDeviceObjects( LPDIRECT3DDEVICE8 pd3dDevice );
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
private:
    HRESULT RenderText(int iWidth, int iHeight);

    static MenuItem m_pOptionsMenuItems[];

    CD3DFont*   m_pFont;                // Font for drawing text
    int         m_iCurSel;
};