// RadiusBehavior.cpp: implementation of the CRadiusBehavior class.
//
//////////////////////////////////////////////////////////////////////

#include "RadiusBehavior.h"
#include "GameMath.h"
#include <crtdbg.h>     //for _ASSERT()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRadiusBehavior::CRadiusBehavior()
{

}

CRadiusBehavior::~CRadiusBehavior()
{

}

CAbstractItemBehavior* CRadiusBehavior::Clone(const char* pszIdentifier, ifstream& infile)
{
    _ASSERT(pszIdentifier);

    if(strcmp(pszIdentifier, "RADIUS") == 0)
    {
        CRadiusBehavior* pNewItem = new CRadiusBehavior();
        infile >> pNewItem->m_fRadius;
        return pNewItem;
    }
    return NULL;
}

BOOL CRadiusBehavior::CheckInBounds(CSnake* pSnake, CItem* pItem)
{
    _ASSERT(pSnake && pItem);

    D3DXVECTOR3 vFrom = *pSnake->GetLeadPoint();
    D3DXVECTOR3 vTo = vFrom + pSnake->GetDirection();
    D3DXVECTOR3 vIntersect;
    if(CGameMath::GetPointPerp(vFrom, vTo, pItem->m_vPos, &vIntersect))
    {
        vIntersect -= pItem->m_vPos;
        FLOAT fCheckRadius = m_fRadius + pSnake->m_fScaleRadius;
        if(D3DXVec3LengthSq(&vIntersect) < fCheckRadius * fCheckRadius)
            return TRUE;
    }
    return FALSE;
}