// CRotateBehavior.cpp: implementation of the CRotateBehavior class.
//
//////////////////////////////////////////////////////////////////////

#include "RotateBehavior.h"
#include <crtdbg.h>     //for _ASSERT

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRotateBehavior::CRotateBehavior() : m_vRotateInc(0.0f, 0.0f, 0.0f)
{

}

CRotateBehavior::~CRotateBehavior()
{

}

CAbstractItemBehavior* CRotateBehavior::Clone(const char* pszIdentifier, ifstream& infile)
{
    _ASSERT(pszIdentifier);

    if(strcmp(pszIdentifier, "ROTATE") == 0)
    {
        CRotateBehavior* pNewItem = new CRotateBehavior();
        infile >> pNewItem->m_vRotateInc.x
               >> pNewItem->m_vRotateInc.y
               >> pNewItem->m_vRotateInc.z;
        return pNewItem;
    }
    return NULL;
}

void CRotateBehavior::FrameMove(CItem& moditem, CCourseLoader* pCourse,
                                CItem* pItem, UINT iItemSize, CSnakeManager* pSnakeManager)
{
    moditem.m_vRotation += m_vRotateInc;

    //recenter the x rotation
    while(moditem.m_vRotation.x > 2 * 3.1415f)
        moditem.m_vRotation.x -= 2 * 3.1415f;
    while(moditem.m_vRotation.x < 0.0f)
        moditem.m_vRotation.x += 2 * 3.1415f;

    //recenter the y rotation
    while(moditem.m_vRotation.y > 2 * 3.1415f)
        moditem.m_vRotation.y -= 2 * 3.1415f;
    while(moditem.m_vRotation.y < 0.0f)
        moditem.m_vRotation.y += 2 * 3.1415f;

    //recenter the z rotation
    while(moditem.m_vRotation.z > 2 * 3.1415f)
        moditem.m_vRotation.z -= 2 * 3.1415f;
    while(moditem.m_vRotation.z < 0.0f)
        moditem.m_vRotation.z += 2 * 3.1415f;
}