// ScoreBehavior.cpp: implementation of the CScoreBehavior class.
//
//////////////////////////////////////////////////////////////////////

#include "ScoreBehavior.h"
#include <crtdbg.h>     //for _ASSERT

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CScoreBehavior::CScoreBehavior()
{

}

CScoreBehavior::~CScoreBehavior()
{

}

CAbstractItemBehavior* CScoreBehavior::Clone(const char* pszIdentifier, ifstream& infile)
{
    _ASSERT(pszIdentifier);

    if(strcmp(pszIdentifier, "SCORE") == 0)
    {
        CScoreBehavior* pNewItem = new CScoreBehavior();
        infile >> pNewItem->m_fScoreMod;
        return pNewItem;
    }
    return NULL;
}

void CScoreBehavior::Reset(CItem& moditem, CCourseLoader* pCourse)
{
    m_fCurScore = m_fScoreMod;
}

void CScoreBehavior::FrameMove(CItem& moditem, CCourseLoader* pCourse,
                        CItem* pItem, UINT iItemSize, 
                        CSnakeManager* pSnakeManager)
{
    //every four frames decrease score by one
    if(m_fCurScore > 1.0f)
        m_fCurScore -= 0.25f;
}

BOOL CScoreBehavior::ModifySnake(CSnake* pSnake)
{
    _ASSERT(pSnake);
    pSnake->m_iScore += (int)m_fCurScore;
    return FALSE;
}