// ServerMenu.h: interface for the CServerMenu class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include "AbstractMenu.h"
#include "CourseLoader.h"
#include "NetworkManager.h"
#include "d3dfile.h"
#include "d3dfont.h"
#include "dxutil.h"

class CServerMenu : public CAbstractMenu
{
public:
	CServerMenu(CNetworkManager* pnetman);
	virtual ~CServerMenu();

    // CAbstractMenu functions
    virtual int OnKeyDown(WPARAM wParam);
    virtual int OnChar(WPARAM wParam);
    virtual int FrameMove();

	// Device Initialization and Rendering Functions
    virtual void RenderMenu(int iWidth, int iHeight);
    virtual HRESULT InitDeviceObjects( LPDIRECT3DDEVICE8 pd3dDevice );
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();

private:
    HRESULT RenderText(int iWidth, int iHeight);

    static MenuItem         m_pServerMenuItems[];
    
    CD3DFont*               m_pStatusFont;       // Font for drawing text
    CD3DFont*               m_pMenuFont;         // Font for drawing text
    TCHAR                   m_pszIPAddr[256];

    CNetworkManager*        m_pNetManager;
    int                     m_iCurSel;
    BOOL                    m_bHasRendered;      //ensure that render has occured
};