// TitleMenu.h: interface for the CTitleMenu class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include "AbstractMenu.h"
#include "d3dfile.h"
#include "d3dfont.h"
#include "dxutil.h"

class CTitleMenu : public CAbstractMenu
{
public:
	CTitleMenu();
	virtual ~CTitleMenu();

    // CAbstractMenu functions
    virtual int  OnKeyDown(WPARAM wParam);
    virtual int  FrameMove();

	// Device Initialization and Rendering Functions
    virtual void RenderMenu(int iWidth, int iHeight);
    virtual HRESULT InitDeviceObjects( LPDIRECT3DDEVICE8 pd3dDevice );
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
private:
    HRESULT RenderText(int iWidth, int iHeight);

    static MenuItem m_pTitleMenuItems[];

    CD3DMesh*   m_pTitleMesh;
    CD3DFont*   m_pFont;                // Font for drawing text
    FLOAT       m_fRotAngle;
    FLOAT       m_fTexOffset;
    int         m_iCurSel;
};