// WallSection.h: interface for the CWallSection class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include <D3dx8math.h>
#include "customvertex.h"
#include <fstream>
using namespace std;

class CWallSection  
{
public:
	CWallSection();
	~CWallSection();

    //load the wall section from the file
    void LoadFromFile(ifstream& infile);

    //returns whether the line segment intersects a wall or not
    BOOL GetWallIntersect(const D3DXVECTOR3 &vFrom, const D3DXVECTOR3 &vTo,
                          D3DXVECTOR3* pvIntersect = NULL, 
                          D3DXVECTOR3* pvWallFrom = NULL,
                          D3DXVECTOR3* pvWallTo = NULL);

    //returns the distance squared to the nearest wall to the point given
    FLOAT GetNearestWall(const D3DXVECTOR3 &vPoint, D3DXVECTOR3* pvWallFrom = NULL, D3DXVECTOR3* pvWallTo = NULL);

    //returns a new windows regions defining the wall outline
    HRGN CreateWallRegion();

    //draw the walls on the given Direct3DDevice for DEBUG purposes only
    void    Render(LPDIRECT3DDEVICE8 pd3dDevice, const VECTOR2TEX* pWallSect, UINT iWallSectSize);
protected:
    D3DXVECTOR3*    m_pWallVert;
	FLOAT			m_fWallHeight;
    UINT            m_iWallVertSize;
};