// WaterPlane.h: interface for the CWaterPlane class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#include "Snake.h"
#include <vector>
#include <d3d8.h>
#include <d3dx8.h>

using namespace std;

class CWaterPlane
{
public:
    CWaterPlane(const D3DXVECTOR3& vPos, const D3DXVECTOR2& vSize, const UINT iHorzDiv, const UINT iVertDiv);
    ~CWaterPlane();

    //updates the splash list for the water
    void UpdateSplashes(CSnake* pSnake);

    // Device Initialization and Rendering Functions
    void Render();
    HRESULT InitDeviceObjects( LPDIRECT3DDEVICE8 pd3dDevice );
    HRESULT RestoreDeviceObjects();
    HRESULT InvalidateDeviceObjects();
    HRESULT DeleteDeviceObjects();

    HRESULT FrameMove();
protected:
    struct SplashInfo
    {
        D3DXVECTOR2  m_vPos;
        UINT        m_iStage;
    };

    LPDIRECT3DDEVICE8       m_pd3dDevice;
    LPDIRECT3DVERTEXBUFFER8 m_pWaterVB;         //vertex buffer for the water
    LPDIRECT3DINDEXBUFFER8  m_pWaterIB;         //index buffer for the water
    LPDIRECT3DTEXTURE8      m_pWaterTexture;    //texture for the water
    LPDIRECT3DVERTEXBUFFER8 m_pSplashVB;        //vertex buffer for the splash
    LPDIRECT3DTEXTURE8      m_pSplashTexture;   //texture for the splash
    vector<SplashInfo>      m_SplashVect;

    D3DXVECTOR3             m_vPos;
    FLOAT                   m_fHeight;
    FLOAT                   m_fWidth;
    UINT                    m_iHorzDiv;
    UINT                    m_iVertDiv;
    WORD*                   m_pOffsetIndices;
    BOOL*                   m_pOffsetDirs;
};