#pragma once

struct CUSTOMVERTEX
{
    FLOAT x, y, z;
	FLOAT nx, ny, nz;
    DWORD color;
	FLOAT tu, tv;
};

#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE | D3DFVF_TEX1)


struct TEXTUREVERTEX
{
    FLOAT x, y, z, rhw; // The transformed position for the vertex.
    DWORD color;
    FLOAT tu, tv;
};

#define D3DFVF_TEXTUREVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE |  D3DFVF_TEX1)

struct COLORVERTEX
{
    FLOAT x, y, z, rhw; // The transformed position for the vertex.
    DWORD color;
};

#define D3DFVF_COLORVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE)

//two dimensional vertex coordinates with a texture mapping coordinate
struct VECTOR2TEX
{
    VECTOR2TEX() : x(0.0f), y(0.0f), tu(0.0f) {}
    VECTOR2TEX(FLOAT fx, FLOAT fy, FLOAT ftu) : x(fx), y(fy), tu(ftu) {}
    FLOAT       x;
    FLOAT       y;
    FLOAT       tu;     
};